#--------------------------
# True anim for povray 3.5, Graphic User Interface
# ------------------------- 
# jm soler 02-->08/2002
#--------------------------
ver='15a.00'
#--------------------------
#
# V.14j :
#    Added:
# - recomputation of normals if you don't want to remove Double Sided option. 
#   fixed bug
# - correct the "realSize" 
#
# V.14i:
#    Added:
# - Povray's Material Design Interface: can modify, add, create
#   normal texture with bump_map, pattern or normal_map, transforms
#   
# V.14 :
#    Added:
# - Povray's Material Design Interface: to modify, add, create
#   colors, pigments, finishs, normals [,interior, media, texture] 
#   no export for the moment
#
# V.12s :
#    Added:
# - light_group for megapov and povray3.5.     
#
# V.12r fixed bugs:
# - Light positions when they were sized with negative value give 
#   false results for rotation. Animation of object with negative 
#   size.
# - Faces without vertexpaint color get the object color default 
#   when material was attributed to object not to mesh. 
# - No more confusion with keywords of povray : capitalize first
#   character of every name exported... 
# - Now export  only object  of the current scene.
#
#    Added:
# - "interpolate" button in Extra Material window. 
# - The "texture_maps" format can be used insteed 
#   of "pigment_maps". Note that this new format is
#   not faster (that's widely the opposite) but it
#   seems useful. 
#
# V.12q fixed bugs:
# - Object Name and mesh names had to be identical. Now can be different.
# - material given to object crashed export ... sometime. Fixed (I hope).
#
#    Added:
# - Use of light distance in povray and light power method are "toggled" 
#   in the second light control windows. 
# - objects with no "valid" faces are not exported now.   
#
#    
# V.12p
#    Added:
# - Extra materials: "Global Reflection" to set all relflection to a given value
#   or to not reflection at all; "Global Map Value" to set the power value of the 
#   uvmapped textures in pigment_map/texture_map; "Global paint Value" to set 
#   the power value of the vertex paint textures in pigment_map/texture_map
#   (perhaps not complete, to do: pigment not defined in test_list) 
#
# - Postprocess for Megapov. 3 windows: focal blur, posterize, find_edges
#
#
# V.12o fixed bugs:
#  - object with negative or null size: transformations are replaced by matrix    
#  - All export option problem
#   
#    Added:
#  - Expert Mode : with this option script exports without stop on errors
#  - Photons parameters
#
# V.12n fixed bugs:
#  - while materials' or objects' first character name was a number,
#    povray's parcing returned an error
#  - at present doesn't export any more indefined vertices coordinates 
#  - multi-materials mesh without uvmap texture or colours painted can
#    be exported
#  - material's color wasn't exported as float number because the round 
#    limit was inverted with patch variable
# 
#    Modified:
#  - windows order
#
#    Problems:
#  - the "all" export options button 
#--------------------------

yes=1
no=0

# Select the patchtype for exportation format
povray35=0
megapov07=1
patchtype=megapov07

format='inc'
debug='debug'

inifile=yes
main=yes
world=yes
mesh=yes
material=yes
lamp=yes
camera=yes
curframe=yes
expertmode=no
recalcnorm=no

GlobRefl=yes
GlobMapVal=1.0
GlobPaintVal=1.0

FadePower=1.0
FadeDistance=1.0

Interpol=1.0
InterpolType=1.0

export=[inifile,  main,
        world,    mesh,
        material, lamp,
        camera,   curframe,
        expertmode,  
        [[0,GlobRefl], 
         [0,GlobMapVal], 
         [0,GlobPaintVal],
         [FadeDistance,FadePower],
         [Interpol,InterpolType]
        ],
         recalcnorm
       ]

# Select globalsettings exportation
# look at globla_set.py to make your
# own settings
global_settings=no
localGT=no

# Animation tags:
doAnim=no

startFrame=0
endFrame=256

noAnimCamera=no
noAnimMaterial=no
noAnimLamp=no

anim=[doAnim, startFrame, endFrame, noAnimCamera, noAnimMaterial, noAnimLamp]

# Select the layers to be exported...
# to work an object have to be moved before
# exportation
layer=[1,1,0,0,0, 0,0,0,0,0,
       1,0,0,0,0, 1,0,0,0,0]

FullLayer=no

if FullLayer==yes:
  layer=[1,1,1,1,1,
         1,1,1,1,1,
         1,1,1,1,1,
         1,1,1,1,1]

#texturestype[0]=0 exportation non optimise
#texturestype[0]=1 exportation optimise
#texturestype[1]=0 average pigment_map
#texturestype[1]=1 average texture_map
#texturestype[2]=0 standard text_list
#texturestype[2]=1 separate textures file and text_list

texturestype=[1,0,0]

Ttexturestype=['Short    ',
               ' Pigment  ',
               'Text_list']


"""
This file tests the lib xptrueA_12o.pyc
Note: the blender file and lib can be in the
same directory if you copy these lines in a
the script windows.
"""
import sys
import Blender
import Blender.Draw
from Blender.Draw import *
import Blender.BGL
from Blender.BGL import *


L=sys.path
ls=Blender.Get('filename')
ls=Blender.sys.dirname(ls)
sys.path.append(ls)

"""
If you have a different directory for your script
don't forget to write the address in the python 
button in the info windows.  
"""

import povanim15a_01  
reload(povanim15a_01)
from povanim15a_01 import *
xptrueA_=povanim15a_01
 
G_Set=[]

G_Set0=[['global_settings{',' '],
        ['}',' ']]

#--------------------------------------------------------
#  Standard Global settings
#--------------------------------------------------------

G_standard=[
# name                     : value :min    :max    :export : event :reset value

#['\t\t hf_gray_16',        'off',  0      , 1     , 0     ,1       ,0],

['\t\t assumed_gamma',      2.2  ,  0.0    , 3.0   , 0     ,2       ,2.2],
['\t\t max_trace_level',    20   ,  1      , 100   , 0     ,3       ,20 ],
#['\t\t adc_bailout',       1.0/255.0,  1.0/255.0*3],
#['\t\t max_intersections', 64],
#['\t\t number_of_waves',   10],
#['\t\t noise_generator',   3],

#['\t\t ambient_light',     '<1.0 ,1.0 ,1.0 >'],
#['\t\t irid_wavelength',   '<0.25,0.18,0.14>'],

#[' ',' ']
]

#--------------------------------------------------------
#  Radiosity
#--------------------------------------------------------

Tnumb=100

G_rad=[
['\t\t radiosity {',' '],

# name                     : value :min    :max    :export : event :reset value
['\t\t\t media'            , 'off' , 0     , 1     ,0      , 1     ,   0],
['\t\t\t normal'           , 'off' , 0     , 1     ,0      , 2     ,   0],

['\t\t\t count'            , 500   , 1     , 1600  ,0      , 3     ,  500],
['\t\t\t nearest_count'    , 10    , 1     , 20    ,0      , 4     ,   10],
['\t\t\t error_bound'      , 0.02  , 0.01  , 2.0   ,0      , 5     , 0.02],
['\t\t\t recursion_limit'  , 1     , 1     , 20    ,0      , 6     ,    1],
['\t\t\t low_error_factor' , 0.2   , 0.01  , 1.0   ,0      , 7     ,  0.2],
['\t\t\t gray_threshold'   , 0.0   , 0.0   , 1.0   ,0      , 8     ,  0.0],
['\t\t\t minimum_reuse'    , 0.015 , 0.005 , 0.05  ,0      , 9     ,0.015],
['\t\t\t brightness'       , 1.0   , 0.1   , 2.0   ,0      , 10    ,  1.0],
['\t\t\t adc_bailout'      , 0.005 , 0.001 , 0.01  ,0      , 11    ,0.005],
['\t\t\t pretrace_start'   , 0.08  , 0.01  , 0.1   ,0      , 12    , 0.08],
['\t\t\t pretrace_end'     , 0.01  , 0.01  , 0.5   ,0      , 13    , 0.01],

['\t\t}',' '],
]

def clean(B,r):
 return  B[r][0].replace('\t\t\t ','')

Dradiosity={}

for r in range(1,len(G_rad)-1):
   if G_rad[r][1]!='off':
      Dradiosity[clean(G_rad,r)]=Create(G_rad[r][1])
   else:
      Dradiosity[clean(G_rad,r)]=Create(0)
 
Tgradiosity={}
for r in range(1,len(G_rad)-1):
      Tgradiosity[clean(G_rad,r)]=Create(G_rad[r][4])

#--------------------------------------------------------
#  Photons
#--------------------------------------------------------

Tphot=200 

G_phot=[   
['\t\t photons {', ' '],

# name                    : value   :min    :max    :export : event   :reset value
['\t\t\t media'           , 0       ,  0    , 1     ,0      ,  1      ,   0       ],
['\t\t\t autostop'        , 0       ,  0    , 1     ,0      ,  2      ,   0       ],

['\t\t\t gather'          , '20,100',0      ,1      ,0      ,  3      ,'20,200'   ],

['\t\t\t spacing'         , 0.010   ,0.010  ,0.2    ,0      ,  4      , 0.010     ],
['\t\t\t jitter'          , 0.4     ,0.1    ,1.0    ,0      ,  5      , 0.4       ], 
['\t\t\t range_divider'   , 0.0     ,0.0    ,0.1    ,0      ,  6      , 0.0       ],
['\t\t\t count'           , 2000    ,500    ,20000  ,0      ,  7      , 2000      ],

['\t\t}','\n']
] 

Dphotons={}

for r in range(1,len(G_phot)-1):
   if G_phot[r][1]!='off':
      Dphotons[clean(G_phot,r)]=Create(G_phot[r][1])
   else:
      Dphotons[clean(G_phot,r)]=Create(0)
 
Tgphotons={}
for r in range(1,len(G_phot)-1):
      Tgphotons[clean(G_phot,r)]=Create(G_phot[r][4])


#--------------------------------------------------------
#  Extra light
#--------------------------------------------------------

TFadeDistance=Create(FadeDistance)
TFadePower=Create(FadePower)

#--------------------------------------------------------
#  Extra material
#--------------------------------------------------------

TnumExtMat=300

TGlobRefl=Create(0)
TGlobMapVal=Create(0)
TGlobPaintVal=Create(0)

SGlobRefl=Create(1.0)
SGlobMapVal=Create(GlobMapVal)
SGlobPaintVal=Create(GlobPaintVal)

#--------------------------------------------------------
#  Extra material : uvmapped img 
#--------------------------------------------------------

TInterpol=Create(Interpol)
TInterpolType=Create(InterpolType)

#--------------------------------------------------------
#  Extra material : material design interface
#--------------------------------------------------------
TModifMaterial=Create(0)
TGlobalWeight=Create(1)

dimensionfen=[74,295,258,16]  
dim=dimensionfen
boardBlimit=100
butt=xptrueA_.buttons(dim[0],dim[1],dim[2],dim[3],boardBlimit)
butt.analyse_structure()

butt.create_buttons()
initcf=[1.0,0.3,0.3,0.3]
xptrueA_.shown_object='pigment'
xptrueA_.MATLIST, xptrueA_.MATcorNameLIST, xptrueA_.MATNameLIST, menumaterial=xptrueA_.getmat(xptrueA_.Extramat)
Mmaterial=Create(1)


#--------------------------------------------------------
#  Postprocess
#--------------------------------------------------------

Sfindedges=Create(0)
Sposterize=Create(0)
Sfocalblur=Create(0)

findedges=no
posterize=no
focalblur=no

Mpostprod=Create(1)

#--------------------------------------------------------
#  find edges
#--------------------------------------------------------

TpostP0=200

G_postP0=[   
['\t\t\t find_edges {', ' '],

# name                               : value   :min        :max      :export  : event   :reset value
[',//depth_thresh  \n\t\t\t\t '       , 1.0       ,  1.0      , 100.0     ,1       ,  1      ,   1       ],
[',//normal  \n\t\t\t\t '             , 0.3     ,  0.0      , 1.0     ,1       ,  2      ,   0.3       ],
[',//color  \n\t\t\t\t '              , 0.15    ,  0.0      , 1.0     ,1       ,  3      ,   0.15       ],
[',//linear_radius  \n\t\t\t\t '      , 1       ,  1        , 20      ,1       ,  4      ,   1   ],
[',//sharpness  \n\t\t\t\t '          , 1.0       ,0.01     , 2.0     ,1       ,  5      ,   1.0   ],
[',//pigment_statement  \n\t\t\t\t '  , [0.0,0.0,0.0]  , [0.0,0.0,0.0] , [5.0,5.0,5.0]  ,1   ,  6  , [0.0,0.0,0.0]], 
['\t\t\t}\n\t','\n']
]    

DpostP0={}

def clean2(B,r):
   N=B[r][0].replace(',//',''); 
   if N.find('//')!=-1:
      N=N.replace('//','')
   return N.replace(' \n\t\t\t\t ','')

def clean3(B,r):
   N=B[r][0].replace('\t\t\t ','')
   return N.replace(' {','')
   
for r in range(1,len(G_postP0)-2):
    DpostP0[clean2(G_postP0,r)]=Create(G_postP0[r][1])
r=len(G_postP0)-2
DpostP0[clean2(G_postP0,r)+' R']=Create(G_postP0[r][2][0])
DpostP0[clean2(G_postP0,r)+' G']=Create(G_postP0[r][2][1])
DpostP0[clean2(G_postP0,r)+' B']=Create(G_postP0[r][2][2])

#--------------------------------------------------------
#  posterize
#--------------------------------------------------------

TpostP1=210

G_postP1=[   
['\t\t\t posterize {', ' '],
# name                                  : value :min      :max            :export : event :reset value
[',//pigment_statement  \n\t\t\t\t '  , [1,1,1] , [1,1,1] , [48,48,48] ,1      ,  1    ,  [5,5,5] ], 
['\t\t\t}\n\t','\n']
]    

DpostP1={}

DpostP1[clean2(G_postP1,1)+' R']=Create(G_postP1[1][2][0])
DpostP1[clean2(G_postP1,1)+' G']=Create(G_postP1[1][2][1])
DpostP1[clean2(G_postP1,1)+' B']=Create(G_postP1[1][2][2])


#--------------------------------------------------------
#  Focal Blur
#--------------------------------------------------------

TpostP2=220

G_postP2=[   
['\t\t\t focal_blur {', ' '],

# name                               : value   :min        :max      :export  : event   :reset value
[',//field_start  \n\t\t\t\t '     , 1.0     ,  0.0      , 1000.0  ,1       ,  1      ,   1     ],
[',//field_depth  \n\t\t\t\t '     , 1.0     ,  0.10     , 100.0   ,1       ,  2      ,   1.0   ],
[',//max_blur_radius  \n\t\t\t\t ' , 2       ,  1        , 100     ,1       ,  3      ,   2     ],
[',//keep_aa  \n\t\t\t\t '         , 0.5     ,  0.0      , 1.0     ,1       ,  4      ,   0.5   ],
['\t\t\t}\n\t','\n']
]    

DpostP2={}

for r in range(1,len(G_postP2)-1):
      DpostP2[clean2(G_postP2,r)]=Create(G_postP2[r][1])


#print LPostprocess

#--------------------------------------------------------
#  Layers
#--------------------------------------------------------

Blay={}
for bl in range(2,22,1):
  Blay[bl]=Create(layer[bl-2])

#--------------------------------------------------------
#  textures
#--------------------------------------------------------

Btexturestype={}
for tt in range(3):
     Btexturestype[tt]=Create(texturestype[tt])


TFullLayer=Create(0)
  
Tmegapov07=Create(patchtype)
Tpostproc=Create(0)
TFullLayer=Create(0)  

Tformat=Create(1)
Tdebug=Create(1)

Tinifile=Create(inifile)
TlocalInifile=Create(1)

#--------------------------------------------------------
#  Options
#--------------------------------------------------------

Tmain=Create(main)
Tworld=Create(world)
Tmesh=Create(mesh)
Tmaterial=Create(material)
Tlamp=Create(lamp)
Tcamera=Create(camera)
Tcurframe=Create(curframe)
Texpertmode=Create(expertmode)
Trecalcnorm=Create(recalcnorm)
TExpAll=Create(1)
TdoAnim=Create(doAnim)

SstartFrame=Create(startFrame)
SendFrame=Create(endFrame)

TnoAnimCamera=Create(noAnimCamera)
TnoAnimMaterial=Create(noAnimMaterial)
TnoAnimLamp=Create(noAnimLamp)

Tglobal_settings=Create(global_settings)
TlocalGT=Create(localGT)

Tradiosity=Create(0)
Tphoton=Create(0)
Tstandard=Create(0)
TSky_sphere=Create(0)

#--------------------------------------------------------
# exportation
#--------------------------------------------------------

def export_file(anim, patchtype, debug, format, G_Set, layer, export, texturestype):

    global G_phot, G_rad, G_standard, Tradiosity, Tphoton, TSky_sphere, Tstandard, G_Set0
    global SGlobRefl, SGlobMapVal, SGlobPaintVal, TGlobRefl, TGlobMapVal, TGlobPaintVal
    global G_postP0, G_postP1, G_postP2,  DpostP0, DpostP1, DpostP2, Sfindedges, Sposterize 
    global Sfocalblur
    
    postproc=[]
    
    if patchtype==1:
    
       vp=[Sfocalblur, Sposterize,Sfindedges]
       gp=[G_postP2, G_postP1, G_postP0]
       
       for v in vp:
           if v.val==1:
             postproc.append(gp[vp.index(v)]) 
    
    if TGlobRefl.val==1:
       export[9][0][0]=1.0
       export[9][0][1]=SGlobRefl.val
    else:
       export[9][0][0]=0
       export[9][0][1]=0.0
     
    if TGlobMapVal.val==1:
       export[9][1][0]=1.0
       export[9][1][1]=round(SGlobMapVal.val,3)
    else:
       export[9][1][0]=0
       export[9][1][1]=0.0
    
    if TGlobPaintVal.val==1:
       export[9][2][0]=1.0
       export[9][2][1]=round(SGlobPaintVal.val,3)
    else:
       export[9][2][0]=0
       export[9][2][1]=0.0
    
    if len(export[9])<4:
       for adx in range(2):
              export[9].append([0,0])
    
    if TFadeDistance.val==1.0:
       export[9][3][0]=1
       if TFadePower.val==1.0: 
           export[9][3][1]=1
       else:
           export[9][3][1]=2
    else:
       export[9][3][0]=0
       export[9][3][1]=0.0
     
    if TInterpol.val==1.0:
       export[9][4][0]=1
       if TInterpolType.val==1.0: 
           export[9][4][1]=4
       else:
           export[9][4][1]=2
    else:
       export[9][4][0]=0
       export[9][4][1]=0.0
    
    anim=[doAnim, startFrame, endFrame, noAnimCamera, noAnimMaterial, noAnimLamp]
    G_Set=G_Set0[:]
    
    if Tphoton.val==1:
             G_phot2=[G_phot[0]] 
             for lph in range(1,len(G_phot)-1):
                  if G_phot[lph][4]==1:
                     G_phot2.append(G_phot[lph])
                     
             G_phot2.append(G_phot[len(G_phot)-1]) 
             G_Set[1:1]=G_phot2

    if Tradiosity.val==1:
             G_rad2=[G_rad[0]]
             for lph in range(1,len(G_rad)-1):
                  if G_rad[lph][4]==1:
                     G_rad2.append(G_rad[lph])
                     try: 
                       if G_rad2[lph][1]=='off':
                          G_rad2[lph][1]='on'
                     except:
                        pass

             G_rad2.append(G_rad[len(G_rad)-1]) 
             G_Set[1:1]=G_rad2

    if global_settings==1:
        if localGT:
                   xptrueA_.Test_exportVers(patchtype,debug,format,G_Set,0,anim,layer,export,texturestype,postproc)
        else: 
                   xptrueA_.Test_exportVers(patchtype,debug,format, xptrueA_.GT,0,anim,layer,export,texturestype,postproc)
    else:
        xptrueA_.Test_exportVers(patchtype,debug,format,[['','']],0,anim,layer,export,texturestype,postproc)

    #print G_rad
#--------------------------------------------------------
# GUI
#--------------------------------------------------------

glCr=glRasterPos2d
glCl3=glColor3f
glCl4=glColor4f
glRct=glRectf
cf=[0.7,0.68,0.68,0.0]

def trace_rectangle4(r,c):
    glCl4(c[0],c[1],c[2],c[3])
    glRct(r[0],r[1],r[2],r[3])

def trace_rectangle3(r,c,c1):
    glCl3(c[0],c[1],c[2])
    glRct(r[0],r[1],r[2],r[3])
    glCl3(c1[0],c1[1],c1[2])
    
def winPaint():
    global cf

    #glClear(GL_COLOR_BUFFER_BIT)
    glClearColor(cf[0],cf[1],cf[2],cf[3])
    glClear(GL_COLOR_BUFFER_BIT)
    
    script=96
    
    Povwidth=script
    Povheight=16
    Povx=20
    Povy=400

    megawidth=(script+2)*3
    megaheight=16
    megax=20
    megay=Povy-24

    c=[.70,0.3,0.3,0.2]
    c1=[1.0,1.0,1.0,1.0]
    r=[megax-4,megay-4, megax+megawidth+2,megay+8+megaheight]
    trace_rectangle3(r,c,c1)
 
    #texte titre
    glRasterPos2d(20, Povy)
    Text("Blender to Povray 3.5 Anim Exporter, version: "+ver)
    
    r=[20,20,240,10]
    trace_rectangle3(r,c,c1)
 
    r=[28,megay,72,10]
    trace_rectangle3(r,c,c1)

#--------------------------------------------------------
#  Bas de Page pour Draw
#--------------------------------------------------------
def basdepagedraw(l1,l1b,l3,l3b,nW):
      r=[
         [20     , 7, 90, 18],
         [150    , 7, 78, 22],
         [230    , 7, 80, 18],
         [113    , 7, 34, 18],

         [20      , 10+20, 70, 20],
         [20+74   , 10+24, 70, 16],
         [20+74*2 , 10+24, 70, 16],
         [20+74*3 , 10+20, 70, 20]
      ]
      c=[1.0,0.3,0.3,0.2]
      c1=[1.0,1.0,1.0,1.0]
      r0=[
            r[nW][0]-5,
            r[nW][1]-5,
            r[nW][2]+r[nW][0]+5,
            r[nW][3]+r[nW][1]+5
         ]
      trace_rectangle3(r0,c,c1)
 
      Button("Main", 96, r[4][0], r[4][1],r[4][2],r[4][3])
      Button("Radiosity", 97, r[5][0], r[5][1],r[5][2],r[5][3])
      Button("Photons", 98, r[6][0], r[6][1],r[6][2],r[6][3])
      Button("Material", 99, r[7][0], r[7][1],r[7][2],r[7][3])
      
      Button(l1, 21, r[0][0], r[0][1],r[0][2],r[0][3],l1b)
      Button("Export to file", 22, r[1][0], r[1][1],r[1][2],r[1][3],'For the moment, you have to use by yourself povray and the ini file to render')
      Button(l3, 37, r[2][0], r[2][1],r[2][2],r[2][3],l3b)
      Button("Quit", 1, r[3][0], r[3][1],r[3][2],r[3][3])

#--------------------------------------------------------
#  Bas de Page pour Bevent
#--------------------------------------------------------
def BasdepageBevent(evt,a,b):

        if   (evt== 21): windows(a)
        elif (evt== 37): windows(b)

        elif (evt== 99): windows(4)
        elif (evt== 98): windows(3)
        elif (evt== 97): windows(2)
        elif (evt== 96): windows(1)

        elif (evt== 1): Exit()

        elif (evt== 22):
           export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)


#--------------------------------------------------------
#  Main Windows
#--------------------------------------------------------
 
def draw1():
    global Blay, FullLayer, TFullLayer, Tpovray35, Tmegapov07,layer,patchtype,TnoAnimCamera
    global TnoAnimMaterial,TnoAnimLamp, cf
    global SstartFrame, SendFrame,noAnimCamera,noAnimMaterial,noAnimLamp,startFrame, endFrame
    global Tglobal_settings, TlocalGT,localGT,global_settings,anim,TdoAnim,doAnim,Tpostproc
    global format, debug, inifile, main, world, mesh, material,lamp,camera,curframe, export,expertmode, recalcnorm
    global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera,Tcurframe,Texport,TExpAll,Texpertmode,Trecalcnorm
    

    script=96
    Povwidth=script
    Povheight=16
    Povx=20
    Povy=400

    megawidth=(script+2)*3
    megaheight=16
    megax=20
    megay=Povy-24

    c=[0.4,0.1,0.1,0.2]
    c1=[1.0,1.0,1.0,1.0]
    r=[megax+8,megay-4*megaheight+2, megax+megawidth*3+6,megay+2*megaheight]
    trace_rectangle3(r,c,c1)

    winPaint()
    
    #texte commentaire
    glRasterPos2d(megax+script+4, megay+2)
    #Text("Compatibility to patch")

    if Tmegapov07.val==0:
        Tmegapov07=Toggle('MegaPov0.7 compatibility', 23, megax, megay, megawidth, megaheight, Tmegapov07.val,' To export with megapov compatibility.' )
    else:
        Tmegapov07=Toggle('MegaPov0.7 compatibility', 23, megax, megay, megawidth*0.70, megaheight, Tmegapov07.val )
        Button('PostProcess', 24, megax+megawidth*0.71, megay, megawidth*0.29, megaheight )
        #Button("Radio Win"  , 37, 220                 , 10   , 90            , 19        ,'Windows to define new properties to materials and textures.')


    animwidth=script
    animheight=16
    animx=20
    animy=megay-40

    r=[animx-3,animy-4*animheight+2, animx+animwidth*3+6,animy+2*animheight-8]
    trace_rectangle3(r,c,c1)
    
    #texte commentaire
    glRasterPos2d(animx, animy+20)
    Text("Animation options: ")
    
    TnoAnimCamera=Toggle('noAnimCamera', 27, animx, animy, animwidth, animheight, TnoAnimCamera.val )
    TnoAnimMaterial=Toggle('noAnimMaterial', 28, animx+script+2, animy, animwidth, animheight, TnoAnimMaterial.val )
    TnoAnimLamp=Toggle('noAnimLamp', 29, animx+2*(script+2), animy, animwidth, animheight, TnoAnimLamp.val )
    TdoAnim=Toggle('doAnim', 30, animx, animy-19, animwidth+(script+2), animheight, TdoAnim.val )

    SstartFrame=Slider('startFrame', 31 ,animx, animy-19*2, animwidth+(script+2), animheight, SstartFrame.val, 0, 100, 0, ' If startAnim=0 then Blender startAnim value is used instead.' )
    SendFrame=Slider('SendFrame', 32 ,animx, animy-19*3, animwidth+(script+2), animheight, SendFrame.val, 1, 100)

    settwidth=script-2
    settheight=16
    settx=20
    setty=animy-100
    
    r=[settx-3,setty-3, settx+settwidth*2+6,setty+2*settheight-8]
    trace_rectangle3(r,c,c1)
    
    #texte commentaire
    glRasterPos2d(settx, setty+20)
    Text("Global settings: ")

    Tglobal_settings=Toggle('Global Settings', 33, settx, setty, settwidth, settheight, Tglobal_settings.val,'Add inner Standard Settings for radiosity, photons, etc.' )
    if Tglobal_settings.val==0:
       TlocalGT=Toggle('local GT', 34, settx+script+2, setty, settwidth, settheight, 0,'If Global Settings are set, you can define your own Settings in Lights Control window.' )
    else:
       TlocalGT=Toggle('local GT', 34, settx+script+2, setty, settwidth, settheight, TlocalGT.val,'If Global Settings are set, you can define your own Settings in Lights Control window.' )

    setty=animy-76
    settwidth=script-16 
    settx=20+16

    r=[settx+script*2-10, setty-settheight*4,settx+script*2+8+settwidth,setty+4*settheight+8]
    trace_rectangle3(r,cf,c1)

    r=[settx+script*2-2, setty-settheight-4,settx+script*2+6+settwidth,setty+2*settheight+24]
    trace_rectangle3(r,c,c1)
  
    #texte commentaire
    glRasterPos2d(settx+script*2+8, setty+52)
    Text("Textures")
    glRasterPos2d(settx+script*2+8, setty+36)
    Text("Formats")
    
    if Btexturestype[0].val==0:
           Ttexturestype[0]='Longer'
    else:
           Ttexturestype[0]='Shorter'

    if Btexturestype[1].val==0:
           Ttexturestype[1]='Pigment_map'
    else:
           Ttexturestype[1]='Texture_map'

    Btexturestype[0]=Toggle(Ttexturestype[0], 39, 
                        settx+script*2+2+0*settwidth/3, setty+16, 
                        settwidth, settheight-1, Btexturestype[0].val,
                        'Special Export textures format: really shorter and optimised list, or faster export but heavy file')

    Btexturestype[1]=Toggle(Ttexturestype[1], 40, 
                        settx+script*2+2+0*settwidth/3, setty, 
                        settwidth, settheight-1,Btexturestype[1].val,
                        'Special Export textures format: Pigment_map or texture_map (did!)')

    Btexturestype[2]=Toggle(Ttexturestype[2], 41, 
                        settx+script*2+2+0*settwidth/3, setty-16, 
                        settwidth, settheight-1, 0,
                        'Special Export textures format: separate textures files or text_list (to do)')

    setty=animy-100

    expwidth=script
    expheight=16
    expx=20
    expy=setty-35
    
    r=[expx-4,expy-10-expheight*5,expx+expwidth*3+6,expy+expheight+8]
    trace_rectangle3(r,c,c1)
    
    expwidth=script-8
    script=expwidth

    #texte commentaire
    glRasterPos2d(expx, expy+20)
    Text("Exports: ")

    # Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera
   
    Tcurframe=Toggle('Current frame', 36, expx, expy, expwidth, expheight, Tcurframe.val,'Restaure Current frame after the exportation.' )
    Tmain=Toggle('Main', 36, expx+script, expy, expwidth, expheight, Tmain.val,'Export the Main file' )
    Tcamera=Toggle('Camera', 36, expx+script*2, expy, expwidth, expheight, Tcamera.val,'Export Camera' )

    Tmesh=Toggle('Meshes', 36, expx, expy-expheight, expwidth, expheight, Tmesh.val,'Export Meshes with textures, Script suppose that Materials are yet exported.' )
    Tmaterial=Toggle('Materials', 36, expx+script, expy-expheight, expwidth, expheight, Tmaterial.val,'Export Materials' )
    Tlamp=Toggle('Lamps', 36, expx+script*2, expy-expheight, expwidth, expheight, Tlamp.val,'Export Lamp' )
        
    Tformat=Toggle('Format: "inc"', 36, expx, expy-expheight*2, expwidth, expheight, 1 ,'Choose between "inc": better!! no "txt" for the moment, have to be debugged' )
    Tdebug=Toggle('Debug', 36, expx+script, expy-expheight*2, expwidth, expheight, Tdebug.val,'Print lot of infos about exported data' )
    Texpertmode=Toggle('Expert', 36, expx+script*2, expy-expheight*2, expwidth, expheight, Texpertmode.val, 'Expert Mode: doesn\'t stop export on error except for camera.' )

    TExpAll=Toggle('All', 38, expx+script*1.5+expwidth*1.5, expy-expheight*3, expwidth/3, expheight*4, TExpAll.val,'Export All files' )
    
    Trecalcnorm=Toggle('Calculate Norm', 36, expx, expy-expheight*3, expwidth*3, expheight, Trecalcnorm.val, 'Calculate normals for all smoothed faces.' )
    
    
    script=expwidth+8

    Lwidth=22
    Lheight=16
    layerx=20
    layery=setty-88-expheight

    #texte commentaire
    #glRasterPos2d(layerx, layery+Lheight+6)
    #Text("Layers")

    for y in range(2):
      for x in range(10):        
        Blay[y*10+x+2]=Toggle('%s' % (y*10+x+1), y*10+x+2, layerx+x*Lwidth, layery-y*(Lheight), Lwidth, Lheight, Blay[y*10+x+2].val,'Layer')

    TFullLayer=Toggle('All Layers', 35, Lwidth*11, layery-Lheight, Lwidth*3+2, Lheight*2, TFullLayer.val,'Set all Layers on/off.')

    """
    #boutons de sortie
    Button("Quit", 1, 20, 10, 60, 19)
    #bouton de creation des fichiers
    Button("Export to file", 22, 120, 10, 80, 19,'You have to use by yourself povray and the ini file to render')
    #bouton de creation de la forme
    Button("Radio Win", 37, 220, 10, 90, 19,'Windows to define new properties to materials and textures.')
    """
 
    l1='Extra Mat';l1b='Extra material infos/choise and Material Design Interface'
    l3='Light win 1';l3b='Extra material infos/choise and Material Design Interface'

    basdepagedraw(l1,l1b,l3,l3b,4)

def event(evt, val):	
      if (evt== QKEY and not val): Exit()

def bevent1(evt):

      global Blay, FullLayer, TFullLayer, Tpovray35, Tmegapov07,layer,patchtype,TnoAnimCamera
      global TnoAnimMaterial,TnoAnimLamp,Tpostproc
      global SstartFrame, SendFrame,noAnimCamera,noAnimMaterial,noAnimLamp,startFrame, endFrame
      global Tglobal_settings, TlocalGT,localGT,global_settings,anim,TdoAnim,doAnim
      global format, debug, inifile, main, world, mesh, material,lamp,camera, export,expertmode,recalcnorm
      global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera, Texport,Texpertmode,Trecalcnorm
      global texturestype, Ttexturestype, TGlobRefl, TGlobMapVal, TGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal

      BasdepageBevent(evt,4,2)

      """
      if   (evt== 1):  Exit()
      elif (evt== 37): windows(2)
      elif (evt== 22):
           export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)
      """

      if (evt in Blay.keys()):
            for B in Blay.keys():
             layer[B-2]= Blay[B].val

      elif (evt== 24): windows(10)

      elif (evt== 23):
           patchtype=Tmegapov07.val


      elif (evt== 27):
           noAnimCamera=TnoAnimCamera.val
      elif (evt== 28):
           noAnimMateriel=TnoAnimMaterial.val
      elif (evt== 29):
            noAnimLamp=TnoAnimLamp.val
      elif (evt== 30):
           doAnim=TdoAnim.val
      elif (evt== 31):
           startFrame=SstartFrame.val
      elif (evt== 32):
           endFrame=SendFrame.val
      elif (evt== 33):
         global_settings=Tglobal_settings.val

      elif (evt== 34):
         if  Tglobal_settings.val==0:
             TlocalGT.val==0
             Blender.Redraw()

         else:
            localGT=TlocalGT.val
         

      elif (evt== 35):
         for B in Blay.keys():
             Blay[B].val=TFullLayer.val
             layer[B-2]= Blay[B].val

            
      elif (evt== 36):
              if Tformat.val==1:
                format='inc'
              else:
                format='inc'

              if Tdebug.val==1:
                debug='debug'
              else:
                debug=''

              inifile=1
              main=Tmain.val
              world=Tmain.val
              mesh=Tmesh.val
              material=Tmaterial.val
              lamp=Tlamp.val
              camera=Tcamera.val
              curframe=Tcurframe.val
              expertmode=Texpertmode.val
              ex=[inifile,main,world,mesh,material,lamp,camera,curframe,expertmode]
              for x in range(len(ex)):
                 export[x]=ex[x]

              recalcnorm=Trecalcnorm.val
              export[-1]=recalcnorm
  
      elif (evt== 38):
              Tmain.val=TExpAll.val
              Tmesh.val=TExpAll.val
              Tmaterial.val=TExpAll.val
              Tlamp.val=TExpAll.val
              Tcamera.val=TExpAll.val
              Tcurframe.val=TExpAll.val
              Tdebug.val=TExpAll.val
              Texpertmode.val=TExpAll.val
  
              ex=[Tinifile.val,Tmain.val,world,Tmesh.val,Tmaterial.val,Tlamp.val,Tcamera.val,Tcurframe.val,Texpertmode.val]
              for x in range(len(ex)):
                 export[x]=ex[x]
              Trecalcnorm.val=TExpAll.val
              export[-1]=Trecalcnorm.val
 

      elif (evt== 39):
           texturestype[0]=Btexturestype[0].val
      elif (evt== 40):
           texturestype[1]=Btexturestype[1].val



      Blender.Redraw()

#--------------------------------------------------------
#  second Windows 
#--------------------------------------------------------
   
def draw2():
    global Tradiosity, Dradiosity,Tgradiosity,Tnumb, TlocalGTm, TGlobRefl
    global TGlobMapVal, TGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal 
    global format, debug, inifile, main, world, mesh, material,lamp,camera, export,expertmode
    global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera, Texport,Texpertmode

    TRnumb=Tnumb+50

    winPaint()
    #texte titre
    glRasterPos2d(20, 382);Text("Light Controls (1):")
    
    script=96;Povy=400
    megawidth=(script+2)*3;megaheight=16;megax=20;megay=Povy-24;animwidth=script; animheight=16
    animx=40
    animy=megay

    c=[0.8,0.8,0.1,0.2]
    c1=[1.0,1.0,1.0,1.0]

    r=[megax+script-8,megay-15*megaheight, megax+animwidth*3, megay-20]
    trace_rectangle3(r,c,c1)
  
    if Tradiosity.val==1:
        if TlocalGT.val==1:
            Tradiosity =Toggle('Radiosity on', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tradiosity.val,)
        else:
            Tradiosity =Toggle('Radiosity on (not exported)', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tradiosity.val,)

    else:
      Tradiosity =Toggle('Radiosity off', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tradiosity.val,)

    animy=megay-4

    if Tradiosity.val==1:
       for r in range(1,len(G_rad)-1):
             Cr=clean(G_rad,r)

             if G_rad[r][1]!='off' and G_rad[r][1]!='on':
                if Tgradiosity[Cr].val==1:
                     Dradiosity[Cr]=Slider( Cr+' ',Tnumb+G_rad[r][5], animx-20, 
                                         animy-19*(r-1), animwidth+(script*1.65+2),
                                         animheight, Dradiosity[Cr].val, 
                                         G_rad[r][2],G_rad[r][3],1,'Activate parameter: choose the value.' )

                     Button("R", TRnumb+G_rad[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r-1), animwidth/4,
                                 animheight ,'Reset')
                else:
                   Tgradiosity[Cr]=Toggle(Cr+' %s' % round(Dradiosity[Cr].val,3), 
                                  Tnumb+G_rad[r][5],
                                 animx+24, animy-19*(r-1), animwidth+(script+2),
                                 animheight, Tgradiosity[Cr].val,'Toggle to activate this parameter')

                   Button("R", TRnumb+G_rad[r][5] ,animx+24+animwidth+(script+2), 
                               animy-19*(r-1), animwidth/4, animheight ,'Reset')
             else:
                  Dradiosity[Cr]= Toggle(Cr, Tnumb+G_rad[r][5], animx+(r-1)*script*1.7, animy-19, animwidth, 
                                                      animheight,Dradiosity[Cr].val ,'Toggle to activate this parameter')
    else:
       for r in range(1,len(G_rad)-1):
             Cr=clean(G_rad,r)

             if G_rad[r][1]!='off':
                  Tgradiosity[Cr]=Toggle(Cr+' %s' % round(Dradiosity[Cr].val,3), 
                                  Tnumb+G_rad[r][5],
                                 animx+24, animy-19*(r-1), animwidth+(script+2),
                                 animheight, Tgradiosity[Cr].val,'Toggle to activate this parameter')

                  Button("R", TRnumb+G_rad[r][5] ,animx+24+animwidth+(script+2), animy-19*(r-1), animwidth/4,
                                 animheight ,'Reset')

             else:

                  Dradiosity[Cr]= Toggle(Cr, Tnumb, animx+(r-1)*script*1.7, animy-19, animwidth, 
                                                      animheight,Dradiosity[Cr].val ,'Toggle to activate this parameter')
    """              
    Button("Main Win", 21, 20, 10, 90, 19,'Windows to define new properties to materials and textures.')
    Button("Export to file", 22, 140, 10, 80, 19,'nothing but export file')
    Button("Light win2", 37, 230, 10, 80, 19,'')
    """

    l1="Main Win";l1b='Windows to define new properties to materials and textures.'
    l3="Light win2";l3b='photons control and extral global light parameters.'
    basdepagedraw(l1,l1b,l3,l3b,5)


def bevent2(evt):
      global Tradiosity, Tphoton, TSky_sphere,Tnumb,TlocalGT, TGlobRefl, TGlobMapVal, TGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal
      global G_Set, G_Set0, G_rad, G_phot
      global format, debug, inifile, main, world, mesh, material,lamp,camera, export,expertmode
      global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera, Texport,Texpertmode
      
      TRnumb=Tnumb+50
      Tnummax=len(G_rad)-1

      """
      if   (evt== 21): windows(1)
      elif (evt== 37): windows(3)
      elif (evt== 22):
         export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)
      """

      BasdepageBevent(evt,1,3)
      if (evt== 27):
           Blender.Redraw()

      elif (evt>= Tnumb) and (evt<= Tnumb+Tnummax):
           for r in range(3,len(G_rad)-1): 
                if evt== Tnumb+G_rad[r][5]:
                   Cr=clean(G_rad,r)
                   G_rad[r][1]=Dradiosity[Cr].val
                   G_rad[r][4]=Tgradiosity[Cr].val

           for r in range(1,3): 
                if evt== Tnumb+G_rad[r][5]:
                   Cr=clean(G_rad,r)
                   G_rad[r][4]=Dradiosity[Cr].val
                   

           Blender.Redraw()
           
      elif (evt>= TRnumb) and (evt<= TRnumb+Tnummax):
           for r in range(1,len(G_rad)-1): 
                if evt== TRnumb+G_rad[r][5]:
                   Cr=clean(G_rad,r)     
                   Dradiosity[Cr].val=G_rad[r][6]
           Blender.Redraw()

def draw3():
    global Tphoton, Dphotons, Tphot, Tnumb, TlocalGT, TGlobRefl, TGlobMapVal
    global TGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal
    global TFadeDistance,TFadePower, Tgphotons

    TPnumb= Tphot
    TPRnumb=TPnumb+50 

    winPaint()
    #texte titre
    glRasterPos2d(20, 382)
    Text("Light Controls (2):")
    
    script=96;Povy=400;megawidth=(script+2)*3;megaheight=16;megax=20;megay=Povy-24;animwidth=script; animheight=16
    animx=40
    animy=megay

    c=[0.8,0.8,0.1,0.2]
    c1=[1.0,1.0,1.0,1.0]

    r=[megax+script-8,megay-15*megaheight, megax+animwidth*3, megay-20]
    trace_rectangle3(r,c,c1)
  
    if Tphoton.val==1:

      if TlocalGT.val==1:
          Tphoton =Toggle('Photons on', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tphoton.val,)
      else:
          Tphoton =Toggle('Photons on (not exported)', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tphoton.val,)

    else:
         Tphoton =Toggle('Photons off', 27, animx+script+8, animy, animwidth+script*0.7, animheight, Tphoton.val,)

    animy=animy-48

    if Tphoton.val==1:
       for r in range(1,len(G_phot)-1):
             Cr=clean(G_phot,r)
             if G_phot[r][1]!='20,100':
                if Tgphotons[Cr].val==1:
                     Dphotons[Cr]=Slider( Cr+' ',TPnumb+G_phot[r][5], animx-20, 
                                         animy-19*(r-1), animwidth+(script*1.65+2),
                                         animheight, Dphotons[Cr].val, 
                                         G_phot[r][2],G_phot[r][3],1,'Activate parameter: choose the value.' )

                     Button("R", TPRnumb+G_phot[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r-1), animwidth/4,
                                 animheight ,'Reset')
                else:
                   Tgphotons[Cr]=Toggle(Cr+' %s' % round(Dphotons[Cr].val,3), 
                                  TPnumb+G_phot[r][5],
                                 animx+24, animy-19*(r-1), animwidth+(script+2),
                                 animheight, Tgphotons[Cr].val,'Toggle to activate this parameter')

                   Button("R", TPRnumb+G_phot[r][5] ,animx+24+animwidth+(script+2), 
                               animy-19*(r-1), animwidth/4, animheight ,'Reset')
             else:
                  pass
    
    else:
       for r in range(1,len(G_phot)-1):
             Cr=clean(G_phot,r); #print Cr
             if G_phot[r][1]!='20,100':
                  Tgphotons[Cr]=Toggle(Cr+' %s' % round(Dphotons[Cr].val,3), 
                                  TPnumb+G_phot[r][5],
                                 animx+24, animy-19*(r-1), animwidth+(script+2),
                                 animheight, Tgphotons[Cr].val,'Toggle to activate this parameter')

                  Button("R", TPRnumb+G_phot[r][5] ,animx+24+animwidth+(script+2), animy-19*(r-1), animwidth/4,
                                 animheight ,'Reset')

             else:
                  pass

    r=len(G_phot)+1

    glRasterPos2d(animx+24, animy-19*(r-2))
    Text("Extra Light: set/unset fade distance.")

    if TFadeDistance.val==1.0:
        TFadeDistance=Toggle("Fade Distance",TPnumb-1,
                              animx+24, animy-19*(r-1)-4, 
                              (animwidth+script+24)/2,  animheight,
                              TFadeDistance.val,"To choose no Fade Distance")
        
        if TFadePower.val==1.0:
           TFadePower=Toggle("Fade Power = 1",TPnumb-2,
                              animx+24+(script+animwidth+24)/2, animy-19*(r-1)-4, 
                              (animwidth+script+24)/2,animheight,
                              TFadePower.val,"To choose Fade Power")
        else:
           TFadePower=Toggle("Fade Power = 2",TPnumb-2,
                              animx+24+(script+animwidth+24)/2, animy-19*(r-1)-4, 
                              (animwidth+script+24)/2,animheight,
                              TFadePower.val,"To choose Fade Power value")

    else:
        TFadeDistance=Toggle("No Fade Distance",TPnumb-1,
                              animx+24, animy-19*(r-1)-4, 
                              animwidth+script+24,animheight,
                              TFadeDistance.val,"To choose Fade Distance")


    l1="light Win 1";l1b='Windows to define new properties to materials and textures.'
    l2="Export to file";l2b='nothing'
    l3="Extra Material";l3b=''

    basdepagedraw(l1,l1b,l3,l3b,6)

    """
    Button("light Win 1", 21, 20, 10, 90, 19,'Windows to define new properties to materials and textures.')
    Button("Export to file", 22, 140, 10, 80, 19,'nothing')
    Button("Extra Material", 37, 230, 10, 80, 19,'')
    """

def bevent3(evt):
      global Tphoton,TlocalGT, Texport, export
      global G_Set, G_Set0, G_rad, G_phot, Tnumb, Tphot
      global TGlobRefl, TGlobMapVal, TGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal
      global TFadeDistance,TFadePower
      global format, debug, inifile, main, world, mesh, material,lamp,camera, export,expertmode
      global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera, Texport,Texpertmode
      
      TPnumb=Tphot 
      TphotMax=len(G_phot)-1
      TPRnumb=TPnumb+50
      """
      def BasdepageBevent(evt,a,b):

        if   (evt== 21): windows(a)
        elif (evt== 37): windows(b)
        elif (evt== 22):
           export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)
      """
      BasdepageBevent(evt,2,4)

      """
      if   (evt== 21): windows(2)
      elif (evt== 37): windows(4)
      elif (evt== 22):
         export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)
      """

      if (evt== 27) or ((evt >=TPnumb) and (evt <=TPnumb+TphotMax)):
         for r in range(1,TphotMax): 
                if evt== TPnumb+G_phot[r][5]:
                   Cr=clean(G_phot,r)
                   if G_phot[r][1]=='off' and Dphotons[Cr].val==1:
                      G_phot[r][1]=='on'
                   elif G_phot[r][1]=='on' and Dphotons[Cr].val==0:
                      G_phot[r][1]=='off'
                   else:  
                      G_phot[r][1]=Dphotons[Cr].val
                   G_phot[r][4]=Tgphotons[Cr].val

         Blender.Redraw()
      
      elif (evt>= TPRnumb) and (evt<= TPRnumb+TphotMax):
           #print evt 
           for r in range(1,TphotMax): 
                if evt== TPRnumb+G_phot[r][5]:
                   Cr=clean(G_phot,r)
                   #print 'test ',Cr, 'test 2 ', evt
                   Dphotons[Cr].val=G_phot[r][6]
                   Blender.Redraw()
      
      elif (evt== TPnumb-1) or (evt== TPnumb-2):
                   Blender.Redraw()

def draw4():
    global Texport, export
    global TGlobRefl, TGlobMapVal, TGlobPaintVal, SGlobRefl, SGlobMapVal
    global SGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal
    global TFadeDistance,TFadePower, TInterpol, TInterpolType
    global TModifMaterial, Mtxtimg, menutxtimg,TGlobalWeight,Mmaterial
    #global xptrueA_.b,xptrueA_.shown_object, xptrueA_.boardlist,xptrueA_.Tboardlist
    
    winPaint()

    glRasterPos2d(20, 382)
    Text("Extra Material and textures infos Windows")
    script=96;Povy=400;megawidth=(script+2)*3;megaheight=16;megax=20;megay=Povy-24;animwidth=script; animheight=16
    animx=40; animy=megay

    c=[0.8,0.8,0.1,0.2]
    c1=[1.0,1.0,1.0,1.0]

    r=[megax+script-8,megay-15*megaheight, megax+animwidth*3, megay-20]
    trace_rectangle3(r,c,c1)
    
    if TModifMaterial.val==0:

      if TGlobRefl.val==1:
         SGlobRefl=Slider('Reflection Global Value', 33 ,animx, animy-19*3, animwidth+(script*1.6+2), animheight, SGlobRefl.val, 0.0, 1.0, 0,'Set Global Relection value for every object and every material')
         TGlobRefl=Toggle('A', 33 ,animx+ animwidth+(script*1.6+2), animy-19*3, animwidth*0.3, animheight, TGlobRefl.val, 'Activate Reflection value choise.' )
      else:
         TGlobRefl=Toggle('Reflection Value', 33 ,animx, animy-19*3, animwidth*2.8, animheight, TGlobRefl.val, 'Activate Reflection value choise.' )

      if TGlobMapVal.val==1:
         SGlobMapVal=Slider('UV Global Weight', 31 ,animx, animy-19*4, animwidth+(script*1.6+2), animheight, SGlobMapVal.val, 0.0, 10.0, 0, 'Set map value in texture when they are blended with vertex paint.' )
         TGlobMapVal=Toggle('A', 31 ,animx+ animwidth+(script*1.6+2), animy-19*4, animwidth*0.3, animheight, TGlobMapVal.val, 'Activate map value choise.' )
      else:
         TGlobMapVal=Toggle('UV Global Weight', 31 ,animx, animy-19*4, animwidth*2.8, animheight, TGlobMapVal.val, 'Activate map value choise.' )
     
     
      if TGlobPaintVal.val==1:
         SGlobPaintVal=Slider('Vertex Global Weight', 32 ,animx, animy-19*5, animwidth+(script*1.6+2), animheight, SGlobPaintVal.val, 0.0, 10.0, 0, 'Set vertex paint  value in texture when they are blended with texture map' )
         TGlobPaintVal=Toggle('A', 32 ,animx+ animwidth+(script*1.6+2), animy-19*5, animwidth*0.3, animheight, TGlobPaintVal.val, 'Activate vertex paint value choise.' )
      else:
         TGlobPaintVal=Toggle('Vertex Global Weight', 32 ,animx, animy-19*5, animwidth*2.8, animheight, TGlobPaintVal.val, 'Activate vertex paint value choise.' )
     
      

      if TInterpol.val==1.0:
          TInterpol=Toggle("Interpolation",34,
                                animx, animy-19*7 , 
                                animwidth*2.8/2,  animheight,
                                TInterpol.val,"To choose no image interpolation")
          if TInterpolType.val==1.0:
             TInterpolType=Toggle("Type = 4",35,
                                animx+animwidth*2.8/2, animy-19*7, 
                                animwidth*2.8/2,animheight,
                                TInterpolType.val,"To choose Fade Power")
          else:
             TInterpolType=Toggle("Type = 2",35,
                                animx+animwidth*2.8/2, animy-19*7,  
                                animwidth*2.8/2,animheight,
                                TInterpolType.val,"To choose Fade Power value")
      else:
          TInterpol=Toggle("No interpolation",34,
                                animx, animy-19*7, 
                                animwidth*2.8,animheight,
                                TInterpol.val,"To choose image interpolation")
          
      TModifMaterial=Toggle("Material Design interface",40,
                                animx+animwidth, animy-19*1.5 , 
                                animwidth*1.8,  animheight,
                                TModifMaterial.val)

      TGlobalWeight=Toggle("Global Value",41,
                                animx, animy-19*1.5 , 
                                animwidth,  animheight,
                                TGlobalWeight.val)

    else:

      TModifMaterial=Toggle("Material Design Interface",40,
                                animx+animwidth, animy-19*0.9, 
                                animwidth*1.8,  animheight,
                                TModifMaterial.val)

      TGlobalWeight=Toggle("Global Value",41,
                                animx, animy-19*0.9 , 
                                animwidth,  animheight,
                                TGlobalWeight.val)

      glRasterPos2d(animx, animy-19*1.85+2)
      Text("  Select your Material:")
      #Mmaterial,menumaterial
      Mmaterial= Menu(menumaterial,42,animx+animwidth*1.4, animy-19*1.95 , 
                                animwidth*1.4,  animheight , Mmaterial.val)

      Button('Init',43,14, animy-19*3.8, 
                                animwidth*0.5,  animheight*2 )
    
      Button('Add',44,animx+animwidth*0.26, animy-19*2.95, 
                                animwidth*0.63,  animheight )

      Button('Modify',45,animx+animwidth*(0.26+0.63*1), animy-19*2.95, 
                                animwidth*0.63,  animheight )

      Button('Save',46,animx+animwidth*(0.26+0.63*2), animy-19*2.95, 
                                animwidth*0.63,  animheight )

      Button('Load',47,animx+animwidth*(0.26+0.63*3), animy-19*2.95, 
                                animwidth*0.63,  animheight )

      xptrueA_.selectpovobject(xptrueA_.boardlist,
                               xptrueA_.Tboardlist,
                               50,
                               xptrueA_.shown_object,
                               dim)

      butt.draw_buttons(xptrueA_.shown_object)


    l1="Light win2";l1b=''
    l3="Main Win";l3b=''
    basdepagedraw(l1,l1b,l3,l3b,7)

   
def bevent4(evt):
      global Texport, export
      global TGlobRefl, TGlobMapVal, TGlobPaintVal, SGlobRefl, SGlobMapVal
      global SGlobPaintVal, GlobRefl, GlobMapVal, GlobPaintVal
      global TFadeDistance,TFadePower
      global TModifMaterial,Mtxtimg, menutxtimg,TGlobalWeight,boardBlimit
      global Mmaterial, menumaterial
      global format, debug, inifile, main, world, mesh, material,lamp,camera, export,expertmode
      global Tformat, Tdebug, Tinifile, Tmain, Tworld, Tmesh, Tmaterial,Tlamp,Tcamera, Texport,Texpertmode
      BasdepageBevent(evt,3,1)

      """
      if   (evt== 21): windows(3)
      elif (evt== 37): windows(1)
      elif (evt== 22):
         export_file(anim, patchtype, debug, 'inc',  G_Set, layer, export, texturestype)
      """
 
      if (evt== 31):
                  GlobMapVal=SGlobMapVal.val
                  Blender.Redraw()

      elif (evt== 32):
                  GlobPaintVal=SGlobPaintVal.val
                  Blender.Redraw()

      elif (evt== 33):
                  GlobRefl=SGlobRefl.val
                  Blender.Redraw()

      elif (evt== 34) or (evt== 35):
                  Blender.Redraw()

      elif (evt== 40):
            if TModifMaterial.val==1:
               TGlobalWeight.val=0 
            if TModifMaterial.val==0:
               TGlobalWeight.val=1
            Blender.Redraw()
      
      elif (evt== 41):
            if TGlobalWeight.val==0:
               TModifMaterial.val=1
            if TGlobalWeight.val==1:
              TModifMaterial.val=0
            Blender.Redraw()
         
      elif (evt==42):
           Blender.Redraw()
           
      elif (evt== 43):
            xptrueA_.initcf=[.50,.80,0.50,0.2]
            xptrueA_.init_materielInterface(xptrueA_.mat_dico,
                                            xptrueA_.MATcorNameLIST,
                                            xptrueA_.MATNameLIST,
                                            xptrueA_.MATLIST,5)
            for d in xptrueA_.mat_dico.keys():
                 for d1 in  xptrueA_.mat_dico[d].keys():
                    if d1 not in  butt.GUI[d][0][4]:
                         butt.GUI[d][0][4].append(d1)
                         
      elif  (evt== 44):
           print xptrueA_.MATNameLIST[Mmaterial.val-1]
           if xptrueA_.shown_object=='normal':
              print 'butt.GUI[xptrueA_.shown_object][1][-3]',butt.GUI[xptrueA_.shown_object][1][-3]
              b0=butt.GUI['submenu'][butt.GUI[xptrueA_.shown_object][1][-3]].val
              print 'butt.GUI[xptrueA_.shown_object][1][-2]',butt.GUI[xptrueA_.shown_object][1][-2], b0 , butt.GUI['normallist'][0][4]
              addmat0= butt.GUI['normallist'][0][4][b0-1]

              if addmat0!='None':
                 addmat1=xptrueA_.shown_object                                     
                 addmat=[addmat0,addmat1]
                 xptrueA_.Extramat['Add'][xptrueA_.MATcorNameLIST[Mmaterial.val-1]]=addmat
                 print "xptrueA_.Extramat['Add']: ",xptrueA_.Extramat['Add']

              else:
                  try:
                    del xptrueA_.Extramat['Add'][xptrueA_.MATcorNameLIST[Mmaterial.val-1]]
                  except:
                    pass
              
              xptrueA_.MATLIST, xptrueA_.MATcorNameLIST, xptrueA_.MATNameLIST, menumaterial=xptrueA_.getmat(xptrueA_.Extramat)
              
      butt.event_holder(evt,xptrueA_.shown_object,boardBlimit)
     
      for b in xptrueA_.boardlist:
         #print b, xptrueA_.boardlist, len(boardlist)
         if (evt==xptrueA_.boardlist.index(b)+50):
               xptrueA_.shown_object=b
               butt.swap_data(xptrueA_.shown_object)  
               Blender.Redraw()
      

      Blender.Redraw()
     


def draw10():
    global Sposterize, Sfindedges, Sfocalblur, Mpostprod, DpostP0, G_postP0, DpostP1, G_postP1
    global  posterize, findedges, focalblur,TpostP0,TpostP1, TpostP2
    global TFadeDistance,TFadePower
    

    TRpostP0=TpostP0+50 
    TRpostP1=TpostP1+50 
    TRpostP2=TpostP2+50 

    winPaint()

    glRasterPos2d(20, 382)
    Text("Megapov post process")

    script=96;Povy=380;megawidth=(script+2)*3;megaheight=16;megax=20;megay=Povy-24;animwidth=script; animheight=16
    animx=40+10; animy=megay-40

    c=[0.8,0.8,0.7,0.2]
    c1=[1.0,1.0,1.0,1.0]

    r=[megax+script/3,megay-15*megaheight, megax+animwidth*3+4, megay-8]
    trace_rectangle3(r,c,c1)

    
    Mpostprod= Menu("Post Process%t| Find Edges %x1| Posterize%x2| Focal Blur%x3", TpostP0-12, megax+animwidth*3+4-150, 376, 150, 18, Mpostprod.val)



    if Mpostprod.val==1:
     
       Sfindedges=Toggle('Find Edges',TpostP0-3, animx-20, animy+20, 
                                         animwidth+(script*1.65+2), animheight,  Sfindedges.val)

       for r in range(1,len(G_postP0)-2):
             Cr=clean2(G_postP0,r)
             DpostP0[Cr]=Slider( Cr+' ',TpostP0+G_postP0[r][5], 
                                         animx-20, animy-19*(r-1), 
                                         animwidth+(script*1.65+2), animheight, 
                                         DpostP0[Cr].val, 
                                         G_postP0[r][2],G_postP0[r][3],1,'post process, Find edges: choose the value.' )
                    
             Button("R", TRpostP0+G_postP0[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r-1), animwidth/4, animheight ,'Reset')
       
       animy=megay-48
       r=len(G_postP0)-2
       Cr=clean2(G_postP0,r)
       
       if Cr.find('//')!=-1:
          Cr=Cr.replace('//','')
       
       Cl=[' R',' G',' B']
       t=0;c=[DpostP0[Cr+Cl[0]].val,DpostP0[Cr+Cl[1]].val,DpostP0[Cr+Cl[2]].val,0.2]
       c1=[1.0,1.0,1.0,1.0]
       r=[  animx+30,  animy-(r-1)*19, megax+animwidth*2,  animy-(r-1)*19+DpostP0['linear_radius '].val ]
       trace_rectangle3(r,c,c1);r=len(G_postP0)-2

       for n in Cl:
          t+=1
          DpostP0[Cr+n]=Slider( Cr[0:10]+n+' ',TpostP0+G_postP0[r][5], animx-20, 
                                         animy-19*(t+r-1),
                                         animwidth+(script*1.65+2),
                                         animheight, DpostP0[Cr+n].val, 
                                         G_postP0[r][2][t-1],G_postP0[r][3][t-1],1,'post process, Find edges: choose the value.' )

       Button("R", TRpostP0+G_postP0[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r+2), animwidth/4, animheight*3+6 ,'Reset')


    elif Mpostprod.val==2:
       Sposterize=Toggle(' Posterize ',TpostP0-3, animx-20, animy+20, 
                                         animwidth+(script*1.65+2), animheight,  Sposterize.val)
       r=len(G_postP1)-2
       Cr=clean2(G_postP1,1)
       if Cr.find('//')!=-1:
          Cr=Cr.replace('//','')
       Cl=[' R',' G',' B']
       t=0
       for n in Cl:
          t+=1
          DpostP1[Cr+n]=Slider( Cr[0:10]+n+' ',TpostP1+G_postP1[r][5], animx-20, 
                                         animy-19*(t+r-1),
                                         animwidth+(script*1.65+2),
                                         animheight, DpostP1[Cr+n].val, 
                                         G_postP1[r][2][t-1],G_postP1[r][3][t-1],1,'post process, posterize: choose the value.' )

       Button("R", TRpostP1+G_postP1[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r+2), animwidth/4, animheight*3+6 ,'Reset')

    elif Mpostprod.val==3:
       Sfocalblur=Toggle(' Focal Blur ',TpostP0-3, animx-20, animy+20, 
                                         animwidth+(script*1.65+2), animheight,  Sfocalblur.val)
       for r in range(1,len(G_postP2)-1):
             Cr=clean2(G_postP2,r)
             DpostP2[Cr]=Slider( Cr+' ',TpostP2+G_postP2[r][5], 
                                         animx-20, animy-19*(r-1), 
                                         animwidth+(script*1.65+2), animheight, 
                                         DpostP2[Cr].val, 
                                         G_postP2[r][2],G_postP2[r][3],1,'post process, Focal Blur: choose a value.' )
                    
             Button("R", TRpostP2+G_postP2[r][5] ,animx+animwidth+(script*1.65+2)-20, animy-19*(r-1), animwidth/4, animheight ,'Reset')


    l1="Light win2";l1b=''
    l3="Main Win";l3b=''
    basdepagedraw(l1,l1b,l3,l3b,7)
   
def bevent10(evt):
      global Mpostprod,  DpostP0,    G_postP0,    DpostP1, G_postP1, posterize, findedges, focalblur
      global Sposterize, Sfindedges, Sfocalblur,  TpostP0, TpostP1, TpostP2
      global TFadeDistance,TFadePower
 
      TRpostP0=TpostP0+50 
      TRpostP1=TpostP1+50 
      TRpostP2=TpostP2+50 

      BasdepageBevent(evt,3,1)

      if (evt== TpostP0-12):
           Blender.Redraw()
                
      elif (evt== TpostP0-3):
           Blender.Redraw()
      
      if Mpostprod.val==1:
         for r in range(1,len(G_postP0)-2):
               if (evt==TRpostP0+G_postP0[r][5]):
                  Cr=clean2(G_postP0,r)
                  DpostP0[Cr].val=G_postP0[r][6]
               if (evt==TpostP0+G_postP0[r][5]):
                  Cr=clean2(G_postP0,r)
                  G_postP0[r][1]=DpostP0[Cr].val
         t=0
         r=len(G_postP0)-2
         Cr=clean2(G_postP0,r)
         Cl=[' R',' G',' B']
         if (evt==TRpostP0+G_postP0[len(G_postP0)-2][5]):
               for n in Cl:
                   t+=1
                   DpostP0[Cr+n].val=G_postP0[r][6][t-1]

         if (evt==TpostP0+G_postP0[len(G_postP0)-2][5]):
               for n in Cl:
                   t+=1
                   #print G_postP0[r][1],DpostP0[Cr+n].val
                   G_postP0[r][1][t-1]=DpostP0[Cr+n].val

         Blender.Redraw()

      elif Mpostprod.val==2:             
         
         r=len(G_postP1)-2
         Cr=clean2(G_postP1,1)
         Cl=[' R',' G',' B']
         t=0
         
         if (evt==TpostP1+G_postP1[len(G_postP1)-2][5]):
           for n in Cl:
              t+=1 #print DpostP1[Cr+n].val
              G_postP1[r][1][t-1]=DpostP1[Cr+n].val

         t=0
         if (evt==TRpostP1+G_postP1[len(G_postP1)-2][5]):
               for n in Cl:
                   t+=1
                   DpostP1[Cr+n].val=G_postP1[r][6][t-1]
         Blender.Redraw()
  
      elif Mpostprod.val==3:             
         for r in range(1,len(G_postP2)-1):
               if (evt==TRpostP2+G_postP2[r][5]):
                  Cr=clean2(G_postP2,r)
                  DpostP2[Cr].val=G_postP2[r][6]

               if (evt==TpostP2+G_postP2[r][5]):
                  Cr=clean2(G_postP2,r)
                  G_postP2[r][1]=DpostP2[Cr].val
         Blender.Redraw()
          

def windows(number):

   if number==1:
      Register(draw1, event, bevent1)
   elif number==2:
      Register(draw2, event, bevent2)
   elif number==3:
      Register(draw3, event, bevent3)
   elif number==4:
      Register(draw4, event, bevent4)
   elif number==10:
      Register(draw10, event, bevent10)

print "That's began!! :) "; windows(1)